{
  Autor       : Michael Springwald

  Erstellt am : Montag, 05.Mai.2008
  Updates     :
  ------------------------------------------------------------------------------
01- Mittwoch, 07.Mai.2008                 - Montag, 12.Mai.2008                -
  ------------------------------------------------------------------------------
02- Dienstag, 13.Mai.2008                 - Mittwoch, 14.Mai.2008              -
  ------------------------------------------------------------------------------
03-                                       -                                    -
  ------------------------------------------------------------------------------
04-                                       -                                    -
  ------------------------------------------------------------------------------
05-                                       -                                    -
  ------------------------------------------------------------------------------
}

unit uPlutoButton;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Controls, GraphType;

type
  TPlutoButtonTyp = (pbt_Vertikal, pbt_Horizonal);
  TPLAutoSize     = (as_Right=0, as_Bottom=1, as_Both=2, as_None=3);
  

  { PlPlutoStyle }

  PlPlutoStyle = class
    fBrush: TBrush;
    fFont: TFont;
    fPen: TPen;
    fVisible: Boolean;
    procedure SetVisible(const AValue: Boolean);
  private
  protected
    procedure ChangeProp(sender: TObject); Virtual;

  public
    constructor Create;
    destructor Destroy; override;
  published
    property Brush:TBrush read fBrush write fBrush;
    property Font:TFont read fFont write fFont;
    property Pen:TPen read fPen write fPen;
    
    property Visible:Boolean read fVisible write SetVisible;
  end; // PlPlutoStyle
  
  { TPlutoButton }
  TPlutoButton = class(TCustomControl)
  private
    fAutoSize: TPLAutoSize;
    fBrush: TBrush;
    fCaption: String;
    fFont: TFont;
    fGroub: Integer;
    fHotStyle: PlPlutoStyle;
    fOnMouseDown: TMouseEvent;
    fOnMouseMove: TMouseMoveEvent;
    fOnMouseUp: TMouseEvent;
    fPen: TPen;
    fBevelInner: TBevelCut;
    fBevelOuter: TBevelCut;
    fBevelWidth: Integer;
    fBorderWidth: Integer;
    fTextHeight: Integer;
    fTextLeft: Integer;
    fTextTop: Integer;
    fTextWidth: Integer;
    fTyp: TPlutoButtonTyp;
    isClick:Boolean;
    tmpFont:TFont;
    tmpBrush:TBrush;
    isSaveTmpStyle:Boolean;
    fMouseMove:Boolean;
    
    procedure SetCaption(const AValue: String);
    procedure SetTextHeight(const AValue: Integer);
    procedure SetTextLeft(const AValue: Integer);
    procedure SetTextTop(const AValue: Integer);
    procedure SetTextWidth(const AValue: Integer);
    procedure SetTyp(const AValue: TPlutoButtonTyp);
    procedure SetBevelCut(var a:TBevelCut; b:TGraphicsBevelCut; c:TColor);
    procedure setAutoSize(const AValue: TPLAutoSize);

    procedure SaveTmpStyle;
    procedure LoadTmpStyle;
  protected
    procedure Paint; override;
    procedure ChangeProp(sender:TObject);
    
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseLeave; override;
    procedure MouseEnter; override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X,
                    Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property HotStyle:PlPlutoStyle read fHotStyle write fHotStyle;
    property Brush:TBrush read fBrush write fBrush;
    property Font:TFont read fFont write fFont;
    property Pen:TPen read fPen write fPen;

    property BevelInner:TBevelCut read fBevelInner write fBevelInner;
    property BevelOuter:TBevelCut read fBevelOuter write fBevelOuter;
    property BevelWidth:Integer read fBevelWidth write fBevelWidth;
    property BorderWidth:Integer read fBorderWidth write fBorderWidth;
    
    property Caption:String read fCaption write SetCaption;
    property Typ:TPlutoButtonTyp read fTyp write SetTyp;
    property Groub:Integer read fGroub write fGroub;
    property AutoSize:TPLAutoSize read fAutoSize write setAutoSize;

    property TextLeft:Integer read fTextLeft write SetTextLeft;
    property TextTop:Integer read fTextTop write SetTextTop;
    property TextWidth:Integer read fTextWidth write SetTextWidth;
    property TextHeight:Integer read fTextHeight write SetTextHeight;

    // Muss ich wohl selbst Implementieren
    property OnMouseDown:TMouseEvent read fOnMouseDown write fOnMouseDown;
    property OnMouseMove:TMouseMoveEvent read fOnMouseMove write fOnMouseMove;
    property OnMouseUp:TMouseEvent read fOnMouseUp write fOnMouseUp;

    // Einfach nur widerholt damit sie im OI zuverfügung stehen
    property OnClick;
    property OnEnter;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnExit;
  end; // TPlutoButton

implementation

procedure TPlutoButton.SetCaption(const AValue: String);
begin
  if fCaption=AValue then exit;
  fCaption:=AValue;
  Paint;
end; // TPlutoButton.SetCaption

procedure TPlutoButton.SetTextHeight(const AValue: Integer);
begin
  if fTextHeight=AValue then exit;
  fTextHeight:=AValue;
  Paint;
end; // TPlutoButton.SetTextHeight

procedure TPlutoButton.SetTextLeft(const AValue: Integer);
begin
  if fTextLeft=AValue then exit;
  fTextLeft:=AValue;
  Paint;
end; // TPlutoButton.SetTextLeft

procedure TPlutoButton.SetTextTop(const AValue: Integer);
begin
  if fTextTop=AValue then exit;
  fTextTop:=AValue;
  Paint;
end; // TPlutoButton.SetTextTop

procedure TPlutoButton.SetTextWidth(const AValue: Integer);
begin
  if fTextWidth=AValue then exit;
  fTextWidth:=AValue;
  Paint;
end; // TPlutoButton.SetTextWidth

procedure TPlutoButton.SetTyp(const AValue: TPlutoButtonTyp);
var
  t:Integer;
begin
  if fTyp=AValue then exit;
  fTyp:=AValue;
  Paint;
end; // TPlutoButton.SetTyp

procedure TPlutoButton.Paint;
  function GetMaxChar:TPoint;
  var
    i,pw,ph,px,py:Integer;
  begin
    pw:=0; ph:=0; px:=0; py:=0;
    for i:=1 to Length(fCaption) do begin
      pw:=canvas.TextWidth(fCaption[i]);
      ph:=canvas.TextHeight(fCaption[i]);
      if pw > px then px:=pw;
      py:=py+ph+5;
    end;
    result:=point(px+10,py);
  end;
var
  r:TRect;
  x,py:Integer;
  p:TPoint;
begin
  inherited Paint;
  Canvas.Brush.Assign(Brush); Canvas.Font.Assign(Font); Canvas.Pen.Assign(Pen);
  if Typ = pbt_Horizonal then begin
    if fAutoSize in [as_Right, as_Both] then
      Width:=Canvas.TextWidth(fCaption)+TextWidth;

    if fAutoSize in [as_Bottom, as_Both] then
      Height:=Canvas.TextHeight(fCaption)+TextHeight;
  end;

  if Typ = pbt_Vertikal then begin
    p:=GetMaxChar;
    if fAutoSize in [as_Right, as_Both] then Width:=p.X+TextWidth;
    if fAutoSize in [as_Bottom, as_Both] then Height:=p.y+TextHeight;
  end;
  
  r.Left:=0;
  r.Top:=0;
  r.Right:=Width;
  r.Bottom:=Height;
  
  Canvas.Brush.color:=clBtnFace;
  Canvas.Font.color:=clBtnText;
  Canvas.Pen.Color:=clBtnShadow;
  Canvas.FillRect(r);
  if (not HotStyle.Visible) then
    Canvas.Frame3d(r,1,BevelInner)
  else begin
    if fMouseMove then
      Canvas.Rectangle(r);
  end;


  if Typ = pbt_Horizonal then begin
    Canvas.TextOut(TextLeft,TextTop,Caption);
    
  end;

  if Typ = pbt_Vertikal then begin
    py:=TextTop;
    for x:=Length(Caption) downto 1 do begin
      Canvas.TextStyle.Alignment:=taCenter;
      Canvas.TextRect(r,TextLeft,py,Caption[x]);
      
      //Canvas.TextOut(5,py,Caption[x]);
      py:=py+canvas.TextHeight(Caption[x])+5;
    end; // for x
  end;
end; // TPlutoButton.Paint

procedure TPlutoButton.ChangeProp(sender: TObject);
begin
  if Sender is TPen then
    writeln('Pen');
    
  if Sender is TBrush then
    writeln('Brush');
    
  if Sender is TFont then
    writeln('Font');
end; // TPlutoButton.ChangeProp

procedure TPlutoButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  isClick:=True;
  if (isSaveTmpStyle) and (HotStyle.Visible) then begin
    LoadTmpStyle;
    Paint;
  end;

  SetBevelCut(BevelInner,bvLowered,clRed);
  if Assigned(fOnMouseDown) then fOnMouseDown(Self, Button, shift, x,y);
end; // TPlutoButton.MouseDown

procedure TPlutoButton.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseMove(Shift, X, Y);
  if Assigned(fOnMouseMove) then fOnMouseMove(Self, Shift, x,y);
end; // TPlutoButton.MouseMove

procedure TPlutoButton.MouseLeave;
begin
  inherited MouseLeave;
  SetBevelCut(BevelInner,bvRaised,clBlue);
  fMouseMove:=False;
  if not isClick then begin
    if HotStyle.Visible then begin
      LoadTmpStyle;
      Paint;
    end;
  end;
end;

procedure TPlutoButton.MouseEnter;
begin
  inherited MouseEnter;

  if isClick then begin
    SetBevelCut(BevelInner,bvLowered,clRed);
  end
  else begin
    if HotStyle.Visible then begin
      fMouseMove:=True;
      SaveTmpStyle;
//      Brush.Assign(HotStyle.Brush);
  //    Font.Assign(HotStyle.Font);
      Paint;
    end;
  end;

end; // TPlutoButton.MouseEnter

procedure TPlutoButton.SetBevelCut(var a:TBevelCut; b:TGraphicsBevelCut;c:TColor);
begin
  if a <> b then begin
    a:=b;
    Canvas.Brush.color:=c;
    paint;
  end;
end; // TPlutoButton.SetBevelCut

procedure TPlutoButton.setAutoSize(const AValue: TPLAutoSize);
begin
  if fAutoSize=AValue then exit;
  fAutoSize:=AValue;
  Paint;
end; // TPlutoButton.setAutoSize

procedure TPlutoButton.SaveTmpStyle;
begin
  tmpBrush.Assign(Brush);
  tmpFont.Assign(Font);
  isSaveTmpStyle:=True;
end; // TPlutoButton.SaveTmpStyle

procedure TPlutoButton.LoadTmpStyle;
begin
  Brush.Assign(tmpBrush);
  Font.Assign(tmpFont);
  isSaveTmpStyle:=False;
end; // TPlutoButton.LoadTmpStyle

procedure TPlutoButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  isClick:=False;
  SetBevelCut(BevelInner,bvRaised,clRed);
  if Assigned(fOnMouseUp) then fOnMouseUp(Self, Button, Shift, x,y);
end; // TPlutoButton.MouseUp

{ TPlutoButton }
constructor TPlutoButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fBrush:=TBrush.Create; fBrush.OnChange:=@ChangeProp;
  fFont:=TFont.Create; fFont.OnChange:=@ChangeProp;
  fPen:=TPen.Create; fPen.OnChange:=@ChangeProp;
  fTextLeft:=0; fTextTop:=0; fTextWidth:=0; fTextHeight:=0;

  fGroub:=0; fTyp:=pbt_Horizonal;
  BevelInner:=bvRaised;
  isClick:=False;
  fAutoSize:=as_Both;
  
  tmpFont:=TFont.Create;
  tmpBrush:=TBrush.Create;

  HotStyle:=PlPlutoStyle.Create;
  HotStyle.Brush.Color:=clBlack;
  HotStyle.Font.Color:=clYellow;

  isSaveTmpStyle:=False;
  HotStyle.Visible:=True;
  fMouseMove:=False;
end; // TPlutoButton.Create

destructor TPlutoButton.Destroy;
begin
  inherited Destroy;
end; // TPlutoButton.Destroy

{ PlPlutoStyle }

constructor PlPlutoStyle.Create;
begin
  inherited Create;
  fBrush:=TBrush.Create; fBrush.OnChange:=@ChangeProp;
  fFont:=TFont.Create; fFont.OnChange:=@ChangeProp;
  fPen:=TPen.Create; fPen.OnChange:=@ChangeProp;
  fVisible:=true;
end; // PlPlutoStyle.Create

destructor PlPlutoStyle.Destroy;
begin
  inherited Destroy;
end; // PlPlutoStyle.Destroy

procedure PlPlutoStyle.SetVisible(const AValue: Boolean);
begin
  if fVisible=AValue then exit;
  fVisible:=AValue;
end; // PlPlutoStyle.SetVisible

procedure PlPlutoStyle.ChangeProp(sender: TObject);
begin
  if Sender is TPen then
    writeln('Pen');

  if Sender is TBrush then
    writeln('Brush');

  if Sender is TFont then
    writeln('Font');
end; // PlPlutoStyle.ChangeProp

end.

